Index: CKEditor/branches/versions/3.3.x/_source/lang/vi.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/vi.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/lang/vi.js	(revision 5405)
@@ -658,4 +658,5 @@
 	{
 		title			: 'Kiểm tra chính tả ngay khi gõ chữ (SCAYT)',
+		opera_title		: 'Not supported by Opera', // MISSING
 		enable			: 'Bật SCAYT',
 		disable			: 'Tắt SCAYT',
@@ -669,7 +670,21 @@
 		addWord			: 'Thêm Từ',
 		emptyDic		: 'Tên của từ điển không được để trống.',
+		
 		optionsTab		: 'Tùy chọn',
+		allCaps			: 'Ignore All-Caps Words', // MISSING
+		ignoreDomainNames : 'Ignore Domain Names', // MISSING
+		mixedCase		: 'Ignore Words with Mixed Case', // MISSING
+		mixedWithDigits	: 'Ignore Words with Numbers', // MISSING
+		
 		languagesTab	: 'Ngôn ngữ',
+		
 		dictionariesTab	: 'Từ điển',
+		dic_field_name	: 'Dictionary name', // MISSING
+		dic_create		: 'Create', // MISSING
+		dic_restore		: 'Restore', // MISSING
+		dic_delete		: 'Delete', // MISSING
+		dic_rename		: 'Rename', // MISSING
+		dic_info		: 'Initially the User Dictionary is stored in a Cookie. However, Cookies are limited in size. When the User Dictionary grows to a point where it cannot be stored in a Cookie, then the dictionary may be stored on our server. To store your personal dictionary on our server you should specify a name for your dictionary. If you already have a stored dictionary, please type it\'s name and click the Restore button.', // MISSING
+		
 		aboutTab		: 'Thông tin'
 	},
Index: CKEditor/branches/versions/3.3.x/_source/lang/zh-cn.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/zh-cn.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/lang/zh-cn.js	(revision 5405)
@@ -658,4 +658,5 @@
 	{
 		title			: '即时拼写检查',
+		opera_title		: 'Not supported by Opera', // MISSING
 		enable			: '启用即时拼写检查',
 		disable			: '禁用即时拼写检查',
@@ -669,7 +670,21 @@
 		addWord			: '添加单词',
 		emptyDic		: '字典名不应为空.',
+		
 		optionsTab		: '选项',
+		allCaps			: 'Ignore All-Caps Words', // MISSING
+		ignoreDomainNames : 'Ignore Domain Names', // MISSING
+		mixedCase		: 'Ignore Words with Mixed Case', // MISSING
+		mixedWithDigits	: 'Ignore Words with Numbers', // MISSING
+		
 		languagesTab	: '语言',
+		
 		dictionariesTab	: '字典',
+		dic_field_name	: 'Dictionary name', // MISSING
+		dic_create		: 'Create', // MISSING
+		dic_restore		: 'Restore', // MISSING
+		dic_delete		: 'Delete', // MISSING
+		dic_rename		: 'Rename', // MISSING
+		dic_info		: 'Initially the User Dictionary is stored in a Cookie. However, Cookies are limited in size. When the User Dictionary grows to a point where it cannot be stored in a Cookie, then the dictionary may be stored on our server. To store your personal dictionary on our server you should specify a name for your dictionary. If you already have a stored dictionary, please type it\'s name and click the Restore button.', // MISSING
+		
 		aboutTab		: '关于'
 	},
Index: CKEditor/branches/versions/3.3.x/_source/lang/zh.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/zh.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/lang/zh.js	(revision 5405)
@@ -658,4 +658,5 @@
 	{
 		title			: '即時拼寫檢查',
+		opera_title		: 'Not supported by Opera', // MISSING
 		enable			: '啟用即時拼寫檢查',
 		disable			: '關閉即時拼寫檢查',
@@ -669,7 +670,21 @@
 		addWord			: '添加單詞',
 		emptyDic		: '字典名不應為空.',
+		
 		optionsTab		: '選項',
+		allCaps			: 'Ignore All-Caps Words', // MISSING
+		ignoreDomainNames : 'Ignore Domain Names', // MISSING
+		mixedCase		: 'Ignore Words with Mixed Case', // MISSING
+		mixedWithDigits	: 'Ignore Words with Numbers', // MISSING
+		
 		languagesTab	: '語言',
+		
 		dictionariesTab	: '字典',
+		dic_field_name	: 'Dictionary name', // MISSING
+		dic_create		: 'Create', // MISSING
+		dic_restore		: 'Restore', // MISSING
+		dic_delete		: 'Delete', // MISSING
+		dic_rename		: 'Rename', // MISSING
+		dic_info		: 'Initially the User Dictionary is stored in a Cookie. However, Cookies are limited in size. When the User Dictionary grows to a point where it cannot be stored in a Cookie, then the dictionary may be stored on our server. To store your personal dictionary on our server you should specify a name for your dictionary. If you already have a stored dictionary, please type it\'s name and click the Restore button.', // MISSING
+		
 		aboutTab		: '關於'
 	},
Index: CKEditor/branches/versions/3.3.x/_source/plugins/dialog/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/dialog/plugin.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/dialog/plugin.js	(revision 5405)
@@ -313,5 +313,6 @@
 				return;
 
-			var keystroke = evt.data.getKeystroke();
+			var keystroke = evt.data.getKeystroke(),
+				rtl = editor.lang.dir == 'rtl';
 
 			processed = 0;
@@ -346,5 +347,5 @@
 			{
 				// Arrow keys - used for changing tabs.
-				nextId = ( keystroke == 37 ? getPreviousVisibleTab.call( me ) : getNextVisibleTab.call( me ) );
+				nextId = ( keystroke == ( rtl ? 39 : 37 ) ? getPreviousVisibleTab.call( me ) : getNextVisibleTab.call( me ) );
 				me.selectPage( nextId );
 				me._.tabs[ nextId ][ 0 ].focus();
Index: CKEditor/branches/versions/3.3.x/_source/plugins/dialogui/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/dialogui/plugin.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/dialogui/plugin.js	(revision 5405)
@@ -508,5 +508,5 @@
 							element.on( 'keydown', function( evt )
 								{
-									if ( evt.data.getKeystroke() in { 32:1, 13:1 } )
+									if ( evt.data.getKeystroke() in { 32:1 } )
 									{
 										me.click();
Index: CKEditor/branches/versions/3.3.x/_source/plugins/elementspath/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/elementspath/plugin.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/elementspath/plugin.js	(revision 5405)
@@ -169,7 +169,8 @@
 		ev = new CKEDITOR.dom.event( ev );
 
+		var rtl = editor.lang.dir == 'rtl';
 		switch ( ev.getKeystroke() )
 		{
-			case 37 :					// LEFT-ARROW
+			case rtl ? 39 : 37 :					// LEFT-ARROW
 			case 9 :					// TAB
 				element = CKEDITOR.document.getById( idBase + ( elementIndex + 1 ) );
@@ -179,5 +180,5 @@
 				return false;
 
-			case 39 :					// RIGHT-ARROW
+			case rtl ? 37 : 39 :					// RIGHT-ARROW
 			case CKEDITOR.SHIFT + 9 :	// SHIFT + TAB
 				element = CKEDITOR.document.getById( idBase + ( elementIndex - 1 ) );
Index: CKEditor/branches/versions/3.3.x/_source/plugins/format/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/format/plugin.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/format/plugin.js	(revision 5405)
@@ -22,4 +22,5 @@
 			var tag = tags[ i ];
 			styles[ tag ] = new CKEDITOR.style( config[ 'format_' + tag ] );
+			styles[ tag ]._.enterMode = editor.config.enterMode;
 		}
 
Index: CKEditor/branches/versions/3.3.x/_source/plugins/maximize/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/maximize/plugin.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/maximize/plugin.js	(revision 5405)
@@ -79,13 +79,4 @@
 	}
 
-	function getResizeHandler( mainWindow, editor )
-	{
-		return function()
-		{
-			var viewPaneSize = mainWindow.getViewPaneSize();
-			editor.resize( viewPaneSize.width, viewPaneSize.height, null, true );
-		};
-	}
-
 	function refreshCursor( editor )
 	{
@@ -104,4 +95,26 @@
 	}
 
+	/**
+	 * Adding an iframe shim to this element, OR removing the existing one if already applied.
+	 * Note: This will only affect IE version below 7.
+	 */
+	 function createIframeShim( element )
+	{
+		if ( !CKEDITOR.env.ie || CKEDITOR.env.version > 6 )
+			return;
+
+		var shim = CKEDITOR.dom.element.createFromHtml( '<iframe frameborder="0" tabindex="-1"' +
+					' src="javascript:' +
+					   'void((function(){' +
+						   'document.open();' +
+						   ( CKEDITOR.env.isCustomDomain() ? 'document.domain=\'' + this.getDocument().$.domain + '\';' : '' ) +
+						   'document.close();' +
+					   '})())"' +
+					' style="display:block;position:absolute;z-index:-1;' +
+					'progid:DXImageTransform.Microsoft.Alpha(opacity=0);' +
+					'"></iframe>' );
+		return element.append( shim, true );
+	}
+
 	CKEDITOR.plugins.add( 'maximize',
 	{
@@ -119,6 +132,13 @@
 			var outerScroll;
 
+			var shim;
+
 			// Saved resize handler function.
-			var resizeHandler = getResizeHandler( mainWindow, editor );
+			function resizeHandler()
+			{
+				var viewPaneSize = mainWindow.getViewPaneSize();
+				shim && shim.setStyles( { width : viewPaneSize.width + 'px', height : viewPaneSize.height + 'px' } );
+				editor.resize( viewPaneSize.width, viewPaneSize.height, null, true );
+			};
 
 			// Retain state after mode switches.
@@ -197,5 +217,7 @@
 									top : '0px'
 								} );
-							editor.resize( viewPaneSize.width, viewPaneSize.height, null, true );
+
+							shim =  createIframeShim( container );		// IE6 select element penetration when maximized. (#4459)
+							resizeHandler();
 
 							// Still not top left? Fix it. (Bug #174)
@@ -240,4 +262,10 @@
 							// Remove cke_maximized class.
 							container.removeClass( 'cke_maximized' );
+
+							if ( shim )
+							{
+								shim.remove();
+								shim = null;
+							}
 
 							// Emit a resize event, because this time the size is modified in
Index: CKEditor/branches/versions/3.3.x/_source/plugins/scayt/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/scayt/plugin.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/scayt/plugin.js	(revision 5405)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -68,4 +68,9 @@
 			var scayt_control = new window.scayt( oParams );
 
+			scayt_control.afterMarkupRemove.push( function( node )
+			{
+				( new CKEDITOR.dom.element( node, scayt_control.document ) ).mergeSiblings();
+			} );
+
 			// Copy config.
 			var	lastInstance = plugin.instances[ editor.name ];
@@ -235,5 +240,5 @@
 			// SCAYT doesn't work with Opera.
 			if ( CKEDITOR.env.opera )
-				return null;
+				return editor.fire( 'showScaytState' );
 
 			if ( this.engineLoaded === true )
@@ -258,5 +263,5 @@
 			// Default to 'http' for unknown.
 			protocol = protocol.search( /https?:/) != -1? protocol : 'http:';
-			var baseUrl  = 'svc.spellchecker.net/spellcheck31/lf/scayt/scayt22.js';
+			var baseUrl  = 'svc.spellchecker.net/spellcheck31/lf/scayt24/loader__base.js';
 
 			var scaytUrl  =  editor.config.scayt_srcUrl || ( protocol + '//' + baseUrl );
@@ -335,12 +340,4 @@
 			{
 				this.setState( CKEDITOR.TRISTATE_DISABLED );
-
-				editor.on( 'showScaytState', function()
-					{
-						this.removeListener();
-						this.setState( plugin.isScaytEnabled( editor ) ? CKEDITOR.TRISTATE_ON : CKEDITOR.TRISTATE_OFF );
-					},
-					this);
-
 				plugin.loadEngine( editor );
 			}
@@ -449,5 +446,5 @@
 					{
 						label : editor.lang.scayt.title,
-						title : editor.lang.scayt.title,
+						title : CKEDITOR.env.opera ? editor.lang.scayt.opera_title : editor.lang.scayt.title,
 						className : 'cke_button_scayt',
 						onRender: function()
@@ -607,14 +604,28 @@
 					});
 			}
+			
+			var showInitialState = function()
+				{
+					editor.removeListener( 'showScaytState', showInitialState );
+
+					if ( !CKEDITOR.env.opera )
+						command.setState( plugin.isScaytEnabled( editor ) ? CKEDITOR.TRISTATE_ON : CKEDITOR.TRISTATE_OFF );
+					else
+						command.setState( CKEDITOR.TRISTATE_DISABLED )
+				};
+
+			editor.on( 'showScaytState', showInitialState );
+
+			if ( CKEDITOR.env.opera )
+			{
+				editor.on( 'instanceReady', function()
+				{
+					showInitialState();
+				});
+			}
 
 			// Start plugin
 			if ( editor.config.scayt_autoStartup )
 			{
-				var showInitialState = function()
-				{
-					editor.removeListener( 'showScaytState', showInitialState );
-					command.setState( plugin.isScaytEnabled( editor ) ? CKEDITOR.TRISTATE_ON : CKEDITOR.TRISTATE_OFF );
-				};
-				editor.on( 'showScaytState', showInitialState );
 				editor.on( 'instanceReady', function()
 				{
Index: CKEditor/branches/versions/3.3.x/_source/plugins/styles/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/styles/plugin.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/styles/plugin.js	(revision 5405)
@@ -551,5 +551,5 @@
 
 					// Let's merge our new style with its neighbors, if possible.
-					mergeSiblings( styleNode );
+					styleNode.mergeSiblings();
 
 					// As the style system breaks text nodes constantly, let's normalize
@@ -625,5 +625,5 @@
 						 * them before removal.
 						 */
-						mergeSiblings( element );
+						element.mergeSiblings();
 						removeFromElement( this, element );
 
@@ -753,4 +753,8 @@
 		var iterator = range.createIterator();
 		iterator.enforceRealBlocks = true;
+		
+		// make recognize <br /> tag as a separator in ENTER_BR mode (#5121)
+		if ( this._.enterMode ) 
+			iterator.enlargeBr = ( this._.enterMode != CKEDITOR.ENTER_BR );
 
 		var block;
@@ -1058,45 +1062,9 @@
 			{
 				// Check the cached nodes for merging.
-				mergeSiblings( firstChild );
-
-				if ( lastChild && !firstChild.equals( lastChild ) )
-					mergeSiblings( lastChild );
-			}
-		}
-	}
-
-	function mergeSiblings( element )
-	{
-		if ( !element || element.type != CKEDITOR.NODE_ELEMENT || !CKEDITOR.dtd.$removeEmpty[ element.getName() ] )
-			return;
-
-		mergeElements( element, element.getNext(), true );
-		mergeElements( element, element.getPrevious() );
-	}
-
-	function mergeElements( element, sibling, isNext )
-	{
-		if ( sibling && sibling.type == CKEDITOR.NODE_ELEMENT )
-		{
-			var hasBookmark = sibling.getAttribute( '_fck_bookmark' );
-
-			if ( hasBookmark )
-				sibling = isNext ? sibling.getNext() : sibling.getPrevious();
-
-			if ( sibling && sibling.type == CKEDITOR.NODE_ELEMENT && element.isIdentical( sibling ) )
-			{
-				// Save the last child to be checked too, to merge things like
-				// <b><i></i></b><b><i></i></b> => <b><i></i></b>
-				var innerSibling = isNext ? element.getLast() : element.getFirst();
-
-				if ( hasBookmark )
-					( isNext ? sibling.getPrevious() : sibling.getNext() ).move( element, !isNext );
-
-				sibling.moveChildren( element, !isNext );
-				sibling.remove();
-
-				// Now check the last inner child (see two comments above).
-				if ( innerSibling )
-					mergeSiblings( innerSibling );
+				firstChild.type == CKEDITOR.NODE_ELEMENT && firstChild.mergeSiblings();
+
+				if ( lastChild && !firstChild.equals( lastChild )
+					&& lastChild.type == CKEDITOR.NODE_ELEMENT  )
+					lastChild.mergeSiblings();
 			}
 		}
Index: CKEditor/branches/versions/3.3.x/_source/plugins/stylescombo/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/stylescombo/plugin.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/stylescombo/plugin.js	(revision 5405)
@@ -35,4 +35,5 @@
 							style = styles[ styleName ] = new CKEDITOR.style( styleDefinition );
 							style._name = styleName;
+							style._.enterMode = config.enterMode;
 
 							stylesList.push( style );
Index: CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js	(revision 5391)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js	(revision 5405)
@@ -290,11 +290,4 @@
 							iframe.remove();
 
-						frameLoaded = 0;
-
-						var setDataFn = !CKEDITOR.env.gecko && CKEDITOR.tools.addFunction( function( doc )
-							{
-								CKEDITOR.tools.removeFunction( setDataFn );
-								doc.write( data );
-							});
 
 						var srcScript =
@@ -304,6 +297,4 @@
 							// call document.open().
 							( isCustomDomain ? ( 'document.domain="' + document.domain + '";' ) : '' ) +
-
-							( ( 'parent.CKEDITOR.tools.callFunction(' + setDataFn + ',document);' ) ) +
 
 							'document.close();';
@@ -313,7 +304,8 @@
   							' frameBorder="0"' +
   							' title="' + frameLabel + '"' +
-							// With FF, the 'src' attribute should be left empty to
+							// With IE, the custom domain has to be taken care at first,
+							// for other browers, the 'src' attribute should be left empty to
 							// trigger iframe's 'load' event.
-  							' src="' + ( CKEDITOR.env.gecko ? '' : 'javascript:void(function(){' + encodeURIComponent( srcScript ) + '}())' ) + '"' +
+  							' src="' + ( CKEDITOR.env.ie ? 'javascript:void(function(){' + encodeURIComponent( srcScript ) + '}())' : '' ) + '"' +
 							' tabIndex="' + editor.tabIndex + '"' +
   							' allowTransparency="true"' +
@@ -321,6 +313,7 @@
 
 						// With FF, it's better to load the data on iframe.load. (#3894,#4058)
-						CKEDITOR.env.gecko && iframe.on( 'load', function( ev )
-							{
+						iframe.on( 'load', function( ev )
+							{
+								frameLoaded = 1;
 								ev.removeListener();
 
@@ -346,7 +339,7 @@
 					var contentDomReady = function( domWindow )
 					{
-						if ( frameLoaded )
+						if ( !frameLoaded )
 							return;
-						frameLoaded = 1;
+						frameLoaded = 0;
 
 						editor.fire( 'ariaWidget', iframe );
